#include "iom16.h"

long unsigned int counter = 0;  //    
unsigned char B0Pressed = 0;  //   0 (0 -  , 1 - )
unsigned char B1Pressed = 0;  //   1 (0 -  , 1 - )

// 2
//  11059  (1 )  counter.     1,001175 
void init_timer2()
{
  OCR2 = 173;
  TCCR2 = (1 << WGM21) | (1 << CS22);
  TIMSK = (1 << 7);
}

//  /
init_io_ports()
{
  DDRA =(1<< DDA0)|(1<< DDA1)|(1<< DDA2)|(1<< DDA3)|(1<< DDA4)|(1<< DDA5)|(1<< DDA6)|(1<< DDA7);
  DDRB =(1<< DDB0)|(1<< DDB1)|(1<< DDB2)|(1<< DDB3)|(1<< DDB4)|(1<< DDB5)|(1<< DDB6)|(1<< DDB7);
  DDRC =(0<< DDC0)|(0<< DDC1)|(1<< DDC2)|(1<< DDC3)|(1<< DDC4)|(1<< DDC5)|(1<< DDC6)|(1<< DDC7);
  DDRD =(1<< DDD0)|(1<< DDD1)|(1<< DDD2)|(1<< DDD3)|(1<< DDD4)|(1<< DDD5)|(1<< DDD6)|(1<< DDD7);
  
  PORTA =(0<< PA0)|(0<< PA1)|(0<< PA2)|(0<< PA3)|(0<< PA4)|(0<< PA5)|(0<< PA6)|(0<< PA7);
  PORTB =(0<< PB0)|(0<< PB1)|(0<< PB2)|(0<< PB3)|(0<< PB4)|(0<< PB5)|(0<< PB6)|(0<< PB7);
  PORTC =(1<< PC0)|(1<< PC1)|(0<< PC2)|(0<< PC3)|(0<< PC4)|(0<< PC5)|(0<< PC6)|(0<< PC7);
  PORTD =(0<< PD0)|(0<< PD1)|(0<< PD2)|(0<< PD3)|(0<< PD4)|(0<< PD5)|(0<< PD6)|(0<< PD7);
}

//   Pause_ms 
void delay(long unsigned int Pause_ms)
{
  counter = 0;
  while (counter < Pause_ms)
  {

  }
}

void main()
{
  SREG |= (1 << 7); // 
  init_timer2();  // 2   64 ,   173
  init_io_ports();  //  /
  while(1)
  {
    //  0  
    if (B0Pressed == 1) //    , 
    {                   //  PORTB,  
      PORTB++;
      B0Pressed = 0;
      while ((PINC & (1 << PC0)) == 1)
      {}
    }
    else
    {
      if ((PINC & (1 << PC0)) == 1)      // 
      {
        delay(50);        // " "
        if ((PINC & (1 << PC0)) == 1)    // 
        {
          B0Pressed = 1;  //  " "
        }
      }    
    }
    //  1
    if (B1Pressed == 1)  //    , 
    {                     //  PORTB,  
      PORTB--;
      B1Pressed = 0;
      while ((PINC & (1 << PC1)) == 2)
      {}
    }
    else
    {
      if ((PINC & (1 << PC1)) == 2)      // 
      {
        delay(50);        // " "
        if ((PINC & (1 << PC1)) == 2)    // 
        {
          B1Pressed = 1;  //  " "
        }
      }    
    }
  }
}

//   2,     counter
#pragma vector = TIMER2_COMP_vect
__interrupt void inc_delay_counter()
{
  counter++;
}
